<?php
/**
* $Id: mod_pressnews.php ver 20 2010-07-27 11:26:01
* @package: Module Press News
* @author: Stavros Stratakis    (WebGift)
* @email: info@webgift.gr
* @link: http://www.webgift.gr
* @license: Creative Commons 3.0. S.A.
* @copyright: (C) 2006-2010 Elxis.org. All rights reserved
* @version : 2.0
* @description: is a JavaSript-Based module that you can choose a category of elxis cms site and it will show it like Press News!.
**********************************************************************************************************************************/

defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');

if (!class_exists('wgpressnews')){
    class wgpressnews {
        private $moddir = '';
		private $sslmoddir = '';
		private $ssl_live_site = '';         
        private $catid = 0;
        private $contid = '';
        private $moduleclass_sfx='';
        private $nitems = 5;
        private $chars = 100;
        private $ordering = 1;
        private $style = 'horiz';
        private $type = 'scrollfade';
        private $time = 5000;
        private $duration = 1000;
        private $shownav = 1;
        private $display_title=0;
        private $width = 500;
        private $height = 20;
        private $show_title = 1;
        private $title_text = 'Press News';
        private $title_width = 90;
        private $errormsg = '';
        private $where = '';
        private $show_front = 0;
        private $hold_w = 0;
        private $float = 'float:left';
        private $main_w = 0;
        private $com_eforum = 0;
        private $com_bubbles= 0;
        private $eforum = null ;
          
        /**********************/
		/* MAGIC CONSTRUCTOR  */
		/**********************/
		public function __construct($params,$eforum) {
		  global $mainframe ;
			
            $this->moddir = $mainframe->getCfg('live_site').'/modules/mod_pressnews';
			$this->ssl_live_site = $mainframe->getCfg('live_site');
			$ssl = false;
			if (isset($_SERVER['HTTPS'])) {
				if (($_SERVER['HTTPS'] == 'on') || ($_SERVER['HTTPS'] == 1)) {
					$ssl = true;
				}
			} else if (isset($_SERVER['SERVER_PORT']) && ($_SERVER['SERVER_PORT'] == 443)) {
				$ssl = true;
			}
			if ($ssl === true) {
				$this->ssl_live_site = preg_replace('/^(http\:)/i', 'https:', $mainframe->getCfg('live_site'));
				$this->sslmoddir = $this->ssl_live_site.'/modules/mod_pressnews';
			} else {
				$this->sslmoddir = $this->moddir;
			}
            $this->eforum = $eforum;          
            $this->getConfig($params);
		}
        
        /********************************/
		/* GET CONFIGURATION paramsS */
		/********************************/
		private function getConfig($params) {
            global $mainframe;
            
            $this->moduleclass_sfx = $params->get('moduleclass_sfx','');
            $this->catid = intval($params->get('catid',''));
            $this->contid 	= $params->get('contid','');
            $this->nitems = intval($params->get ('nitems',5));
            $this->chars  = eUTF::utf8_trim($params->get ('chars',100));
            $this->show_front	= intval($params->get( 'show_front', 1 ));
            $this->display_title = intval($params->get('display_title',0));
            $this->style = ($params->get ('style','horiz')); 
            $this->type = $params->get ('type','scrollfade'); 
            $this->time = $params->get ('time',5000);
            $this->duration = $params->get('duration',1000);
            $this->shownav  = intval($params->get ('shownav',0));          
            $this->width = $params->get ('width',500);
            $this->height = $params->get ('height',20);
            $this->show_title = intval($params->get ('show_title',1));
            $this->title_width = intval($params->get ('title_width',90));
            $this->title_text = $params->get ('title_text','Press News');
            $this->com_eforum = intval($params->get('com_eforum',0));
            $this->com_bubbles = intval($params->get('com_bubbles',0));
            //Check Ordering
            if($this->com_eforum){
                $this->ordering = (intval($params->get( 'ordering', 1))) ? 'p.hits' : 'p.created'; // 0 = Most Recent First | 1 = Most Hits  
            }else{
                $this->ordering = (intval($params->get( 'ordering', 1))) ? 'a.hits' : 'a.created'; // 0 = Most Recent First | 1 = Most Hits  
            }
            //Check error message of content Items
            if((!$this->com_eforum) && (!$this->com_bubbles)){
                if (empty($this->contid) && $this->catid == ''){
                    $this->errormsg = "You have not choosen a Category or specific content items.
                    You must either choose a Category or genarate specific content items by id and seperated them with comma(,) .";
                    }
                    elseif (!empty($this->contid) && $this->catid != ''){
                        $this->errormsg = "You have choosen a Category and specific content items.
                        You must either choose a Category or genarate specific content items by id and seperated them with comma(,) .";}
            }
            //Not allowed to run 2 components at the same time
            if(($this->com_bubbles == 1) && ($this->com_eforum == 1)){
                $this->errormsg = 'Either eForum Component or IOS bubbles component you must enable! No both of them';
                return;
                }
            if($this->com_eforum == 1){
                $forumdir =  $mainframe->getCfg('absolute_path').'/administrator/components/com_eforum';  
                    if (!file_exists($forumdir.'/config.eforum.php')) {
                       $this->errormsg = 'eForum Component not found!';
                       return;}else{
                          require_once($forumdir.'/config.eforum.php');
                          $cfg = new eforumConfig();
                              if ($cfg->get('OFFLINE') == 1) {
                                  $this->errormsg = 'eForum is currently offline!';
                                  return;
                              }
                        }
                }
            if($this->com_bubbles == 1){
                $bubblesdir =  $mainframe->getCfg('absolute_path').'/administrator/components/com_bubbles';
                   if (!file_exists($bubblesdir.'/config.bubbles.php')) {
                         $this->errormsg = 'IOS Bubbles Component not found!';
                         return;
                         }
            }       
            if ($this->title_width < 10) { $this->title_width =10;}
            if ($this->height < 10) {$this->height=10;}
            if($this->width < 100) {$this->width=100;}
            if($this->duration < 200) { $this->duration =200;}
            if($this->time < 1000) { $this->time = 1000;}
            if($this->chars <40 ) {$this->chars =50;}

            if(!empty($this->contid))
            {
                $contids = explode(',',$this->contid);
                mosArrayToInts($contids);
                if(count($contids > 0)){
                    if(!$this->com_eforum){
                        $this->where = "\n AND a.id IN (".implode(',',$contids).")";               
                        }else{
                            $this->where = "\n AND b.bid IN (".implode(',',$contids).")";
                        }
                }
            }
            else {
                if(!$this->com_eforum){
                $this->where .= ' AND cc.id = '.$this->catid.'';
                }
            }
            if ($this->shownav == 1 ) { $this->hold_w = $this->title_width + $this->width + 40; }
            elseif ($this->show_title == 1) { $this->hold_w = $this->title_width + $this->width;}
            else { $this->hold_w = $this->width + 0 ;}
            $this->main_w =$this->width * $this->nitems;
            }
            
        /*****************/
		/* ERROR MESSAGE */
		/*****************/
		private function errorscreen() {
			echo '<div style="margin: 2px; padding: 3px; border: 1px solid #cc0000; color: #000000; font-weight: normal; background-color: #FFF;">'."\n";
			echo '<span style="font-weight:bold; color: #CC0000;">'._ELX_ERROR."</span><br />\n";
			echo ($this->errormsg != '') ? $this->errormsg : 'Unknown error';
			echo "</div>\n";
		}
            
        /********************************/
		/* CONTENT ITEMS DATABASE RESULT*/
		/********************************/
        private function contentdatabase(){
           global $mosConfig_offset,$my,$lang,$mainframe,$database;
               
           $now = date( 'Y-m-d H:i:s', time() + $mosConfig_offset * 3600 );
           $noauth = !$mainframe->getCfg( 'shownoauth' );
           
           $query = "SELECT a.id AS id, a.title, a.seotitle,a.introtext, a.sectionid, a.catid, cc.seotitle AS seocat, s.seotitle AS seosec" 
           ."\n FROM #__content a"
           ."\n LEFT JOIN #__content_frontpage f ON f.content_id = a.id"
		   ."\n INNER JOIN #__categories cc ON cc.id = a.catid"
 	       ."\n INNER JOIN #__sections s ON s.id = a.sectionid"
	       ."\n WHERE a.state = '1' AND a.sectionid > '0'"
	       ."\n AND ( a.publish_up = '1979-12-19 00:00:00' OR a.publish_up <= '".$now."' )"
           ."\n AND ( a.publish_down = '2060-01-01 00:00:00' OR a.publish_down >= '".$now."' )"
	       ."\n AND ((a.language IS NULL) OR (a.language LIKE '%$lang%'))"
	       ."\n AND ((cc.language IS NULL) OR (cc.language LIKE '%$lang%'))"
	       ."\n AND ((s.language IS NULL) OR (s.language LIKE '%$lang%'))"
           .($noauth ? "\n AND a.access IN (".$my->allowed.") AND cc.access IN (".$my->allowed.") AND s.access IN (".$my->allowed.")" : '')
           .$this->where
	       .( $this->catid ? "\n AND ( a.catid IN (".$this->catid.") )" : '' )
	       .( $this->show_front == "0" ? "\n AND f.content_id IS NULL" : '' )
	       ."\n AND cc.published = '1'"
	       ."\n AND s.published = '1'"
	       ."\n ORDER BY ".$this->ordering." DESC" ;
	       
           $database->setQuery( $query, '#__', $this->nitems, 0 );
	       $rows = $database->loadObjectList();
           return $rows;  
      }

        /***********************************/
		/*COMPONENT EFORUM DATABASE RESULT */
		/***********************************/
        private function eforumdatabase(){
           global $database,$mosConfig_offset;
               
           $now = date( 'Y-m-d H:i:s', time() + $mosConfig_offset * 3600 );
           $query = "SELECT p.id AS id, p.title AS title, p.parent AS topicid,p.created, p.message AS introtext, b.bid,"
           ."\n b.title AS boardtitle, b.seotitle AS boardseo, u.id AS uid,u.username AS postername"
           ."\n FROM #__eforum_posts p"
           ."\n LEFT JOIN #__eforum_boards b ON b.bid=p.bid"
           ."\n LEFT JOIN #__users u ON u.id=p.uid"
           ."\n WHERE b.published='1'"
           ."\n AND ( p.created = '1979-12-19 00:00:00' OR p.created <= '".$now."' )"
           ."\n AND ((b.allowed_groups IS NULL) OR (".$this->eforum->fuser->mgid." IN (b.allowed_groups)))"
           .$this->where
		   ."\n  ORDER BY ".$this->ordering." DESC";
		  
           $database->setQuery($query, '#__',$this->nitems, 0);
		   $rows = $database->loadObjectList();
           return $rows;  
        }
   
        /************************************/
		/*COMPONENT BUBBLES DATABASE RESULT */
		/***********************************/   
        private function bubblesdatabase(){
            global $database;
            
               $query = "SELECT b.id AS id, b.title AS title, b.message AS introtext,b.author AS author,b.uid, b.dateadded"
               ."\n FROM #__bubbles b"
               ."\n LEFT JOIN #__users u ON u.id=b.uid"
			   ."\n  ORDER BY  b.dateadded DESC";
               $database->setQuery($query, '#__',$this->nitems, 0);
			   $rows = $database->loadObjectList();
            return $rows;  
        
    }
		/*************************/
		/* INJECT HTML COPYRIGHT */
		/*************************/
		private function injectCopyright() {
			echo "<!--\n";
			echo "WGPressnews created by Stratakis Stavros for Elxis CMS\n";
			echo 'Copyright (c) '.date('Y')." Web Gift ( http://www.webgift.gr ). All rights reserved.\n";
			echo "-->\n";
		}

		/************************/
		/* MARK MODULE HTML END */
		/************************/
		private function htmlend() {
			echo "<!-- End of WGPressnews by Stavros Stratakis -->\n";
		}

		/************************************/
		/* LOAD JAVASCRIPT AND CSS FILES    */
		/************************************/
		private function loadJSCSS() {
?>
            <script type="text/javascript" src="<?php echo $this->sslmoddir; ?>/js/mootools-un.js"></script>          
            <script language="javascript">
			/* <![CDATA[ */
			var header = document.getElementsByTagName("head")[0];
			var csslink = document.createElement('link');
			csslink.setAttribute('type', 'text/css');
			csslink.setAttribute('rel', 'stylesheet');
			csslink.setAttribute('href', '<?php echo $this->sslmoddir; ?>/css/style.css');
			csslink.setAttribute('media', 'all');
			header.appendChild(csslink);
			/* ]]> */
			</script>
<?php 
		}
        
 		/*********************************/
		/* RUN HTML RUN RUN THE MAGICAL! */
		/*********************************/       
        private function runhtml(){
            global $mosConfig_sef,$mainframe,$lang,$database,$my,$Itemid;
            
            if ($mainframe->getCfg('sef') != 2) {
                $access = !$mainframe->getCfg('shownoauth');
				$query = "SELECT id FROM #__menu WHERE link='index.php?option=com_content' AND published='1'"
				."\n AND ((language IS NULL) OR (language LIKE '%".$lang."%'))"
				.($access ? "\n AND access IN (".$my->allowed.")" : '');
				$database->setQuery($query, '#__', 1, 0);
				
                $_Itemid = intval($database->loadResult());
				$getItemid = ($_Itemid) ? $_Itemid : $Itemid;
				}
                $getItemid +=1;
            
            //Choose the database depending on the circumstance!
            if(($this->com_eforum == 0) && ($this->com_bubbles == 0)){
                $data = $this->contentdatabase();
                if(count($data) == '0'){$this->errormsg = 'There is no content item to display';echo $this->errorscreen(); return;}
            }elseif($this->com_eforum){
                $data = $this->eforumdatabase();
                if(count($data) == '0'){$this->errormsg = 'There is eForum Post to display'; echo $this->errorscreen(); return;}
            }elseif($this->com_bubbles){
                $data = $this->bubblesdatabase();
                if(count($data) == '0'){$this->errormsg = 'There is no Bubble message to display';echo $this->errorscreen(); return;}
            }
            if ($this->style == 'horiz' ) { $this->float = "float:left;"; $upd = "width";}else{$this->float ="";$upd = "height";}?>
            <script type="text/javascript" src="<?php echo $this->sslmoddir; ?>/js/show.js"></script>
            <script type="text/javascript" src="<?php echo $this->sslmoddir; ?>/js/mootools.js"></script>
            <div style="clear: both; margin-bottom:5px;"></div>
            <div id="titles_holder" style="width:<?php echo $this->hold_w;?>px; height:<?php echo $this->height;?>px;">
            <?php if($this->show_title == 1) { ?>
            <div id="title_title" style="line-height:<?php echo ($this->height)-1;?>px; width:<?php echo $this->title_width; ?>px;"> <?php echo $this->title_text; ?>
            :</div><?php } ?>
            <?php if ($this->shownav == 1 ){ ?>
            <div class="title_nav" style="height:<?php echo $this->height;?>px;">
            <a class="prev" style="height:<?php echo $this->height;?>px;" onclick="javascript:title_slider.prev(type_slider);"></a>
            <a class="next" style="height:<?php echo $this->height;?>px;" onclick="javascript:title_slider.next(type_slider);"></a>
            </div><?php } ?>
			<div id="press_news<?php $this->moduleclass_sfx ?>" class="title_slide" style="width:<?php echo $this->width;?>px;height:<?php echo $this->height;?>px;">    
            <?php  if ($this->style == 'horiz' ) { ?>
            <div style="width:<?php echo $this->main_w; ?>px; overflow: hidden; float: left;">
            <?php } ?>
            <?php  if ($this->style == 'vert' ) { ?>
            <div style="height:<?php echo $this->main_w; ?>px; overflow: hidden;"><?php }          
            //Case of Content Items or eForum Post
            if ((!$this->com_bubbles) ){
             foreach($data as $row) {
                if($this->com_eforum){
                    $Itemid +=1;
                    if ($row->topicid > 0 ) {
                        $itemlink = sefRelToAbs('index.php?option=com_eforum&task=view&id='.$row->topicid.'&Itemid='.$Itemid.'&msg='.$row->id, 'eforum/'.$row->boardseo.'/'.$row->topicid.'.html?msg='.$row->id);
                        } else {
                            $itemlink = sefRelToAbs('index.php?option=com_eforum&task=view&id='.$row->id.'&Itemid='.$Itemid, 'eforum/'.$row->boardseo.'/'.$row->id.'.html');
			             }    
                }else{
                $seolink = '';
                if (($mainframe->getCfg('sef') == 2)) {
                $seolink = $row->seosec.'/'.$row->seocat.'/'.$row->seotitle.'.html';
                $itemlink = sefRelToAbs('index.php?option=com_content&task=view&id='.$row->id.'&Itemid='.$getItemid, $seolink);
                } else {
                    $_Itemid = $mainframe->getItemid($row->id);
                    $itemlink = sefRelToAbs('index.php?option=com_content&task=view&id='.$row->id.'&Itemid='.$getItemid, $seolink);
		          }
              }

       	    
            if($this->display_title == 0){
                $full_text = substr(strip_tags($row->title." |--> ".$row->introtext),0,$this->chars).'...';
            } else {
                $full_text =  substr(strip_tags($row->title),0,$this->chars);
            }
            $tpad = $this->height-0 ;
            ?>
            <div style="width:<?php echo $this->width; ?>px; line-height:<?php echo $tpad; ?>px; text-indent:5px; height:<?php echo $this->height; ?>px;<?php echo $this->float; ?>;">
            <a href="<?php echo $itemlink; ?>" title="<?php echo $row->title; ?>"><?php echo $full_text ?></a>
            </div>
            <?php }}
            //Case of IOS bubbles Component!
            else{
            foreach($data as $row) {
            if($this->display_title == 0){
                $full_text = substr(strip_tags($row->title." ::> ".$row->introtext),0,$this->chars).'...';
            } else {
                $full_text =  substr(strip_tags($row->title),0,$this->chars);
            }
            $tpad = $this->height-0 ;
            ?>
            <div style="width:<?php echo $this->width; ?>px; line-height:<?php echo $tpad; ?>px; text-indent:5px; height:<?php echo $this->height; ?>px;<?php echo $this->float; ?>;">
            <span style="color: #fff;"><?php echo $full_text ?></span>
            </div>
            <?php }}?>
            </div>
            </div>
            </div>
            
            <script type='text/javascript'>
            var  title_slider = new TitleTicker("press_news",{type:"<?php echo $this->type; ?>",direction: "forward", auto:"loop", 
            time:<?php echo $this->time; ?>, duration:<?php echo $this->duration; ?>});
            var type_slider="<?php echo $this->type; ?>";
            $("titles_holder").addEvent("mouseenter", function(){title_slider.pause();});
            $("titles_holder").addEvent("mouseleave", function(){title_slider.run(type_slider);});
            </script>
            <div style="clear: both; margin-bottom:5px;"></div>
            <?php
        }

        
		/*********************************/
		/* ECHO ALL THE RESULT OF MODULE */
		/*********************************/
		public function pressnewshow() {
            $this->injectCopyright();
			if ($this->errormsg != '') {
				$this->errorscreen();
				return;
			}
			$this->loadJSCSS();
            $this->runhtml();
			$this->htmlend();        
		}
    }
}

global $mainframe;
if (file_exists($mainframe->getCfg('absolute_path').'/administrator/components/com_eforum/includes/eforum.class.php')) {
	if (isset($GLOBALS['eforum']) && is_object($GLOBALS['eforum']) && ($GLOBALS['eforum'] instanceof elxisForum)) {
		$eforum = $GLOBALS['eforum'];
	} else {
		require_once($mainframe->getCfg('absolute_path').'/administrator/components/com_eforum/includes/eforum.class.php');
		$eforum = new elxisForum();
		$GLOBALS['eforum'] = $eforum;
	}
    $mod_pressnews  = new wgpressnews($params,$eforum);
    $mod_pressnews->pressnewshow();
    unset($mod_pressnews);
} else {
    $mod_pressnews = new wgpressnews($params,null);
    $mod_pressnews->pressnewshow();
    unset($mod_pressnews);
}
?>